<template>
	<div class="login">
		<h2>Se connecter à son compte administrateur</h2>
		<form>
			<label for="pseudo">
				<input
					id="pseudo"
					v-model="pseudo"
					name="pseudo"
					placeholder="pseudo"
					required
					type="text" />
			</label>
			<button
				type="submit"
				@click="submitForm">
				Connexion
			</button>
		</form>
	</div>
</template>

<script lang="ts">
	import { defineComponent } from "vue"
	import type { loginReturn } from "@/composables/useUser.composable"
	import { useUser } from "@/composables/useUser.composable"
	import type { Error } from "#/error"

	const errorHandler = (error: Error | null) => {
		if (!error) return
		alert(error.message)
	}

	interface DataComponent {
		pseudo: string
	}

	export default defineComponent({
		name: "LoginInvitedView",
		data(): DataComponent {
			return {
				pseudo: "",
			}
		},
		methods: {
			async submitForm(event: Event) {
				event.preventDefault() // prevent page reload on form submit
				if (this.pseudo !== "") {
					const user = (await useUser().loginInvited(this.pseudo)) as loginReturn // login user and get response from server using useUser composable
					if (user.valid) {
						alert("You have been logged in")
						location.href = "/choice" // redirect to choice page
					} else {
						errorHandler(user.error) // display error message
					}
				}
			},
		},
	})
</script>

<style lang="scss" scoped>
	.login {
		border: 1px solid #ccc;
		width: 60vw;
		margin: auto;
		text-align: center;

		form {
			width: 40vw;
			margin: 0 auto;
			display: flex;
			padding: 5vw 0;
			align-items: center;
		}
	}
</style>
